# abemed

[![Build Status](https://travis-ci.org/gtournie/bemed.svg?branch=master)](https://travis-ci.org/gtournie/bemed)

Extremely simple and small (~1Kb minified) ABEM class name generator. Developed for using with
[babel-plugin-transform-jsx-abemed](https://github.com/gtournie/babel-plugin-transform-jsx-abemed).

This plugin doesn't apply any string transformation. camelCase should be applied earlier on.

# Syntax

```js
const abem = abemed([options])
abem(block[, element, modifiers, mixins])
```

options: object (default: `{ separators: { element: '__', modifiers: '-' } }`)

block: string
element: string | null
modifiers: string | array | object | null
mixins: string | array | object | null

## Examples

```js
let abem = abemed()
abem('o-animal', 'elephant') // "o-animal__elephant"
abem('o-animal', 'elephant', ['mod1', 'mod2']) // "o-animal__elephant -mod1 -mod2"
abem('o-animal', 'elephant', { mod1: true, mod2: false }, ['mix']) // "o-animal__elephant -mod1 mix"
abem('o-animal', null, null, { mix: true }) // "o-animal mix"

abem = abemed({ separators: { element: '___', modifiers: '--' } })
abem('o-animal', 'elephant', 'mod') // "o-animal___elephant --mod"
```
