'use strict'

const assert = require('assert')
const abem = require('../index')()

const check = (params, result) => tap.equal(abem.apply(null, params), result)

check(['block'], 'block')
check(['block', 'elem'], 'block__elem')
check(['block', 'elem', 'mod'], 'block__elem -mod')
check(['block', 'elem', ['mod1', 'mod2']], 'block__elem -mod1 -mod2')
check(['block', 'elem', { mod1: true, mod2: true }], 'block__elem -mod1 -mod2')
check(['block', 'elem', { mod1: false, mod2: true }], 'block__elem -mod2')
check(['block', 'elem', { mod1: false, mod2: false }, 'mix'], 'block__elem mix')
check(['block', 'elem', { mod1: false, mod2: false }, ['mix1', 'mix2']], 'block__elem mix1 mix2')
check(['block', 'elem', { mod1: false, mod2: false }, { mix1: true, mix2: false }], 'block__elem mix1')
check(['block', null, { mod1: false, mod2: true }, ['mix1', 'mix2']], 'block -mod2 mix1 mix2')
