'use strict'

module.exports = opts => {
  opts = opts || {}
  const separators = opts.separators || {}

  const camelize = str =>
    str.replace(/(?:^|\s)\S/g, (word, index) => (index === 0 ? word.toLowerCase() : word.slice(1).toUpperCase()))

  const elementSeparator = separators.element || '__'
  const modifierSeparator = ' ' + separators.modifier || '-'

  function addClassNames(className, entries, separator) {
    if (typeof entries === 'string') {
      className += separator + entries
    } else if (Array.isArray(entries)) {
      for (let i = 0, len = entries.length; i < len; ++i) className += separator + entries[i]
    } else {
      Object.keys(entries).forEach(prop => {
        if (entries[prop]) className += separator + entry
      })
    }
    return className
  }

  const generate = (block, element, modifiers, mixins) => {
    return addClassNames(
      addClassNames(element ? block + elementSeparator + element : block, mixins, ' '),
      modifiers,
      ' ' + modifierSeparator,
    )
  }

  return { generate, helpers: { be: abe, bem: abem, bemv: abemv } }
}
